diff -urN soojung-0.4.4/admin.php soojung/admin.php
--- soojung-0.4.4/admin.php	2005-02-04 23:53:37.000000000 +0900
+++ soojung/admin.php	2005-02-19 18:07:16.000000000 +0900
@@ -19,7 +19,7 @@
   }
   Soojung::writeConfigFile($_POST["blogname"], $_POST["desc"], $_POST["url"], $_POST["perpage"],
 		    $_POST["fancyurl"], $_POST["notify"], $_POST["adminname"], $_POST["email"],
-		    $password, $_POST["skin"]);
+		    $password, $_POST["skin"], $_POST["license"]);
   echo "<meta http-equiv='refresh' content='0;URL=index.php?compile=t'>";
   exit;
 }
@@ -41,6 +41,7 @@
 }
 
 function export_mode() {
+  global $blog_name;
   $filename = $blog_name . '-' . date("Ymd", time()) . '.dat';
   header("Content-Type: application/octet");
   header("Content-Disposition: filename=" . $filename);
@@ -58,6 +59,8 @@
     Import::importTatterTools($_POST["db_server"], $_POST["db_user"], $_POST["db_pass"], $_POST["db_name"], $_POST["prefix"], $_POST["encoding"]);
   } else if ($_POST["mode"] == "import_wp") {
     Import::importWordPress($_POST["db_server"], $_POST["db_user"], $_POST["db_pass"], $_POST["db_name"], $_POST["prefix"], $_POST["encoding"]);
+  } else if ($_POST["mode"] == "import_zb") {
+    Import::importZeroboard($_POST["db_server"], $_POST["db_user"], $_POST["db_pass"], $_POST["db_name"], $_POST["prefix"], $_POST["encoding"], $_POST["boardid"]);
   }
   $temp = new Usertemplate("index.tpl", 1);
   $temp->clearCache();
@@ -70,7 +73,7 @@
 }
 
 function clear_referer_mode() {
-  unlink("contents/.referer");
+  @unlink("contents/.referer");
 }
 
 if ($_POST["mode"] == "login") {
@@ -108,6 +111,7 @@
   $template->assign("blog_fancyurl", $blog_fancyurl);
   $template->assign("blog_notify", $notify);
   $template->assign("blog_skin", $blog_skin);
+  $template->assign("license", $entries_license);
   $template->assign("admin_name", $admin_name);
   $template->assign("admin_email", $admin_email);
   $template->assign("templates", Soojung::getTemplates());
@@ -115,8 +119,18 @@
 } else if ($_GET["mode"] == "data") {
   $template->display('data.tpl');
 } else if ($_GET["mode"] == "list") {
-  $entry_structs = array();
-  $template->assign('entries', Entry::getAllEntries(false));
+  if(isset($_GET["page"])) {
+    $page = $_GET["page"];
+  } else {
+    $page = 1;
+  }
+  if ($page > 1) {
+    $template->assign('prev_page_link', "admin.php?mode=list&page=" . ($page - 1));
+  }
+  if (Entry::getEntryCount() > $page * 10) {
+    $template->assign('next_page_link', "admin.php?mode=list&page=" . ($page + 1));
+  }
+  $template->assign('entries', Entry::getEntries(10, $page));
   $template->display('list.tpl');
 } else {
   $template->assign('recent_entries', Entry::getRecentEntries(5));
@@ -125,4 +139,6 @@
   $template->assign('entry_count', Entry::getEntryCount());
   $template->display('overview.tpl');
 }
-?>
\ No newline at end of file
+
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/bookmark.php soojung/bookmark.php
--- soojung-0.4.4/bookmark.php	2004-12-19 12:52:16.000000000 +0900
+++ soojung/bookmark.php	2005-02-20 11:13:25.000000000 +0900
@@ -9,24 +9,21 @@
 }
 
 /* for posting new bookmark */
-
-if ($_POST["mode"] == "post") {
-  $url = $_POST["url"];
-  $desc = $_POST["desc"];
-
-  if (strstr ($url, "://") == FALSE)
-    $url = 'http://' . $url;
-
-  if (empty($url) || $url == 'http://')  {
-    echo "<font color=\"red\">WARNING: Input url correctly</font>";
-  } else {
-    if (Bookmark::addBookmark ($url, $desc) == false) {
-      echo "<font color=\"red\">WARNING: bookmark already exist</font>";    
-    }
+if ($_POST["mode"] == "delete") {
+  $del_list = $_POST["delchk"];
+  foreach($del_list as $number => $chk) {
+    Bookmark::deleteBookmark($number);    
   }
 } else if ($_GET["mode"] == "delete") {
-  $url = $_GET["url"];
-  Bookmark::deleteBookmark($url);
+  $number = $_GET["number"];
+  Bookmark::deleteBookmark($number);
+} else if ($_GET["mode"] == "move") {
+  $number = $_GET["number"];
+  $offset = intval($_GET["offset"]);
+  Bookmark::moveBookmark($number, $offset);
+  /* XXX without refresh moving, file doesnt save correctly */
+  echo "<meta http-equiv='refresh' content='0;URL=bookmark.php'>";
+  exit;
 }
 
 $template = new AdminTemplate;
@@ -35,6 +32,8 @@
 if (empty($bookmarks)) {
   $bookmarks = array();
 }
+
 $template->assign('bookmarks', $bookmarks);
 $template->display('bookmark.tpl');
-?>
\ No newline at end of file
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/bookmark_post.php soojung/bookmark_post.php
--- soojung-0.4.4/bookmark_post.php	1970-01-01 09:00:00.000000000 +0900
+++ soojung/bookmark_post.php	2005-02-20 11:13:25.000000000 +0900
@@ -0,0 +1,51 @@
+<?php
+session_start();
+
+include("settings.php");
+
+if (!isset($_SESSION["auth"])) {
+  echo "<meta http-equiv='refresh' content='0;URL=admin.php'>";
+  exit;
+}
+
+if ($_POST["mode"] == "post") {
+  $number = $_POST["number"];
+  $name = $_POST["name"];
+  $image = $_POST["image"];
+  $url = $_POST["url"];
+  $desc = $_POST["desc"];
+  
+  if (strstr ($url, "://") == FALSE)
+    $url = 'http://' . $url;
+
+  /* check each entry property */
+  if (empty($url) || $url == 'http://')  {
+    echo "<font color=\"red\">WARNING: Input url correctly</font>";
+  } else {
+    if (Bookmark::bookmarkWrite ($number, $name, $url, $desc, $image) == false) {
+      /* for each error code */
+      echo "<font color=\"red\">WARNING: bookmark already exist</font>";    
+    }
+  } 
+  /* if it succeed */
+  echo "<meta http-equiv='refresh' content='0;URL=bookmark.php'>";
+  exit;
+} else if ($_GET["number"]) { // edit
+  $bookmark = Bookmark::getBookmark($_GET["number"]);
+  $number = $bookmark->number;
+  $name = $bookmark->name;
+  $image = $bookmark->image;
+  $desc = $bookmark->desc;
+  $url = $bookmark->url;
+}
+
+$template = new AdminTemplate;
+$template->assign("number", $number);
+$template->assign("name", $name);
+$template->assign("image", $image);
+$template->assign("url", $url);
+$template->assign("desc", $desc);
+$template->display('bookmark_post.tpl');
+
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/classes/AdminTemplate.class.php soojung/classes/AdminTemplate.class.php
--- soojung-0.4.4/classes/AdminTemplate.class.php	2004-12-19 12:52:16.000000000 +0900
+++ soojung/classes/AdminTemplate.class.php	2005-02-19 14:52:46.000000000 +0900
@@ -10,4 +10,8 @@
     $this->cache_dir = "templates/.admin_cache/";
     $this->template_dir = "templates/admin/";
   }
-}
\ No newline at end of file
+}
+?>
+<?
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/classes/Archive.class.php soojung/classes/Archive.class.php
--- soojung-0.4.4/classes/Archive.class.php	2004-12-03 20:11:41.000000000 +0900
+++ soojung/classes/Archive.class.php	2005-02-19 10:46:05.000000000 +0900
@@ -4,27 +4,41 @@
   var $year;
   var $month;
 
-  function Archive($year, $month) {
+  function Archive($year, $month, $day = 0) {
     $this->year = intval($year);
     $this->month = intval($month);
+    $this->day = intval($day);
   }
 
   function getDate() {
-    return mktime(0, 0, 0, $this->month, 1, $this->year);
+    return mktime(0, 0, 0, $this->month, $this->day ? $this->day : 1, $this->year);
   }
 
   function getHref() {
     global $blog_baseurl, $blog_fancyurl;
 
-    if ($blog_fancyurl) {
-      return sprintf('%s/%04d/%02d', $blog_baseurl, $this->year, $this->month);
+    if ($this->day) {
+      if ($blog_fancyurl) {
+	return sprintf('%s/%04d/%02d/%02d', $blog_baseurl, $this->year, $this->month, $this->day);
+      } else {
+	return sprintf('%s/index.php?archive=%04d%02d%02d', $blog_baseurl, $this->year, $this->month, $this->day);
+      }
     } else {
-      return sprintf('%s/index.php?archive=%04d%02d', $blog_baseurl, $this->year, $this->month);
+      if ($blog_fancyurl) {
+	return sprintf('%s/%04d/%02d', $blog_baseurl, $this->year, $this->month);
+      } else {
+	return sprintf('%s/index.php?archive=%04d%02d', $blog_baseurl, $this->year, $this->month);
+      }
     }
   }
 
   function getEntries() {
-    $filenames = Soojung::queryFilenameMatch(sprintf("^%04d%02d[^.]+[.]entry$", $this->year, $this->month));
+    if ($this->day) {
+      $pattern = sprintf("^%04d%02d%02d[^.]+[.]entry$", $this->year, $this->month, $this->day);
+    } else {
+      $pattern = sprintf("^%04d%02d[^.]+[.]entry$", $this->year, $this->month);
+    }
+    $filenames = Soojung::queryFilenameMatch($pattern);
     rsort($filenames);
     $entries = array();
     foreach($filenames as $filename) {
@@ -33,13 +47,23 @@
     return $entries;
   }
 
+  function getEntryCount() {
+    if ($this->day) {
+      $pattern = sprintf("^%04d%02d%02d[^.]+[.]entry$", $this->year, $this->month, $this->day);
+    } else {
+      $pattern = sprintf("^%04d%02d[^.]+[.]entry$", $this->year, $this->month);
+    }
+    return Soojung::queryNumFilenameMatch($pattern);
+  }
+
   /**
    * static method
    */
   function getArchive($name) {
-    $year = substr($name, 0, 4);
-    $month = substr($name, 4, 2);
-    return new Archive($year, $month);
+    $year = intval(substr($name, 0, 4));
+    $month = intval(substr($name, 4, 2));
+    $day = intval(substr($name, 6, 2));
+    return new Archive($year, $month, $day);
   }
 
   /**
@@ -69,4 +93,5 @@
 
 }
 
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/classes/Bookmark.class.php soojung/classes/Bookmark.class.php
--- soojung-0.4.4/classes/Bookmark.class.php	2004-11-06 02:56:06.000000000 +0900
+++ soojung/classes/Bookmark.class.php	2005-02-20 11:13:25.000000000 +0900
@@ -2,10 +2,40 @@
 
 class Bookmark {
   
+
+  /**
+   * Bookmark file name:
+   * [number].bookmark
+   *
+   * Bookmark file structure:
+   * Name: [name]\r\n
+   * URL: [url]\r\n
+   * ImageLink: [url]\r\n
+   * Desc: [desc]\r\n
+   */
+  
   /** 
    * add personal bookmark file 
    */
-  function addBookmark($url, $desc) {
+  function Bookmark($filename) {
+    $this->filename = $filename;
+    $fd = fopen($filename, "r");
+    $this->number = Soojung::filenameToEntryId($filename);
+    $this->name = trim(strstr(fgets($fd, 1024), ' '));
+    $this->url = htmlspecialchars(trim(strstr(fgets($fd, 1024), ' ')), ENT_QUOTES, "UTF-8");
+    $this->image = htmlspecialchars(trim(strstr(fgets($fd, 1024), ' ')), ENT_QUOTES, "UTF-8");
+    $this->desc = trim(strstr(fgets($fd, 1024), ' '));
+    fclose($fd);
+  }
+
+  function getBookmark($number) {
+    if (empty($number)) return false;
+    $filename = 'contents/.bookmark/' . $number . '.bookmark';
+    return new Bookmark($filename);
+  }
+
+  /*
+  function addBookmark($name, $url, $desc, $image) {
     if (empty($desc)) {
       $desc = $url;
     }
@@ -21,52 +51,115 @@
     Bookmark::writeBookmark($bookmarks);
     return true;
   }
+  */
 
-  /** 
-   * delete personal bookmark, key is url (not description) 
-   */
-  function deleteBookmark($url) {
-    $bookmakrs = Bookmark::getBookmarkList();
-    $new_bookmakrs = array();
-    foreach($bookmakrs as $b) {
-      if ($b['url'] !== $url) {
-	$new_bookmarks[] = $b;
+  function bookmarkWrite($number, $name, $url, $desc, $image) {
+    if (empty($number) || !isset($number) || $number == 0) {
+      /* get last number + 1 */
+      $filenames = Soojung::queryFilenameMatch("^[0-9]+[.]bookmark$", "contents/.bookmark/");
+      sort($filenames);
+      $last_index = count($filenames) - 1;
+
+      if (empty($filenames[$last_index]) || !isset($filenames[$last_index]) || $filenames[$last_index] == "") {
+	$number = 1;
+      } else {
+	$number = Soojung::filenameToEntryId($filenames[$last_index]) + 1;
       }
     }
-    Bookmark::writeBookmark($new_bookmarks);
+    $filename = "$number.bookmark";
+    @mkdir('contents/.bookmark');
+    $fd = fopen('contents/.bookmark/'. $filename, "w");
+
+    fwrite($fd, "Name: ". $name. "\r\n");
+    fwrite($fd, "URL: ". $url. "\r\n");
+    fwrite($fd, "ImageLink: ". $image. "\r\n");
+    fwrite($fd, "Desc: ". $desc. "\r\n");
+    fclose($fd);
+
+    return true;
   }
 
-  /** 
-   * writing $bookmarks to file
-   */
-  function writeBookmark($bookmarks) {
-    $fd = fopen("contents/.bookmark", "w");
-    if (!empty($bookmarks)) {
-      foreach ($bookmarks as $b) {
-	fwrite ($fd, $b['url'] . " " . $b['desc'] . "\r\n");
+  /* rename it */
+  function moveBookmark($number, $offset) {
+#    return false;
+    $bookmarks = Bookmark::getBookmarkList();
+    $index = -1;
+    $bookmark = Bookmark::getBookmark($number);
+    foreach ($bookmarks as $key => $b) {
+      if ($b->number == $number) {
+	$index = $key;
+	break;
       }
     }
-    fclose($fd);
+
+    if ($index == -1)
+      {
+	return false;
+      }
+    $index_new = $index + $offset;
+    /* check $index_new is in range */
+    if ($index_new < 0)
+      $index_new = 0;
+    else if ($index_new >= count($bookmarks))
+      $index_new = count($bookmarks) -1;
+
+
+    $b = $bookmarks[$index];
+    $b_new = $bookmarks[$index_new];
+
+    Bookmark::bookmarkWrite($b_new->number, $b->name, $b->url, $b->desc, $b->image);
+    Bookmark::bookmarkWrite($b->number, $b_new->name, $b_new->url, $b_new->desc, $b_new->image);
+
+  }
+
+  /** 
+   * delete personal bookmark, key is url (not description) 
+   */
+  function deleteBookmark($number) {
+    $filename = "contents/.bookmark/$number.bookmark";
+    unlink($filename);
   }
 
+
   /** 
    * read $bookmarks from file
    */
   function getBookmarkList() {
-    $bookmarks = array();
-    if (!file_exists("contents/.bookmark")) {
-      return $bookmarks;
-    }
-    $fd = fopen("contents/.bookmark", "r");
-    while (!feof($fd)) {
-      $line = trim(fgets($fd, 1024));
-      $b = explode(" ", $line, 2);
-      if (!empty($b[0])) {
-	$bookmarks[] = array("url"=>$b[0], "desc" => $b[1]);
+    if (is_file("contents/.bookmark")) {
+      $bookmarks = array();
+      if (!file_exists("contents/.bookmark")) {
+	return $bookmarks;
       }
+      rename("contents/.bookmark", "contents/.bookmark_old");
+      $fd = fopen("contents/.bookmark_old", "r");
+
+      $number = 0;
+      while (!feof($fd)) {
+	$number++;
+	$line = trim(fgets($fd, 1024));
+	$b = explode(" ", $line, 2);
+	if (!empty($b[0])) {
+	  Bookmark::bookmarkWrite($number, $b[1], $b[0], $b[1], null);
+	  $bookmark = array("url"=>$b[0], "desc" => $b[1]);
+	}
+      }
+      fclose($fd);
+      unlink("contents/.bookmark_old");
+    }
+     
+    $entries = array();
+    $filenames = Soojung::queryFilenameMatch("^[0-9]+[.]bookmark$", "contents/.bookmark/");
+    natsort($filenames);
+
+    for ($i = 0; $i < count($filenames); $i++) {
+      $bookmark = new Bookmark($filenames[$i]);
+      $bookmarks[] = $bookmark;
     }
+
     return $bookmarks;
   }
+
 }
 
-?>
\ No newline at end of file
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/classes/Calendar.class.php soojung/classes/Calendar.class.php
--- soojung-0.4.4/classes/Calendar.class.php	2005-01-22 19:43:49.000000000 +0900
+++ soojung/classes/Calendar.class.php	2005-02-19 10:46:05.000000000 +0900
@@ -1,121 +1,107 @@
 <?php
-
 class Calendar {
   var $year;
   var $month;
   var $day;
 
   function Calendar($year, $month, $day) {
-    if (!$year && !$month)
-      list($year, $month) = $this->get_year_month();
-    $this->year = $year;
-    $this->month = $month;
-    $this->day = $day;
-  }
-
-  function get_year_month() {
-    return list($year, $month) = split(" ", date("Y m"));
+    $this->year = $year ? $year : date("Y");
+    $this->month = $month ? $month : date("m");
+    $this->day = $day ? $day : date("d");
   }
 
-  function get_month_href($year, $month) {
+  function getMonthHref($year, $month) {
     global $blog_baseurl, $blog_fancyurl;
 
-    if ($month<1) {
-      --$year;
-      $month = 12;
-    } elseif ($month>12) {
-      ++$year;
-      $month = "01";
-    }
-    if (strlen($month)<=1)
-      $month = "0".$month;
-    if (strlen($year)<=1)
-      $year = "0".$year;
-
-    if ($blog_fancyurl)
-      return "$blog_baseurl/$year/$month";
-    else
-      return "$blog_baseurl/?archive=$year$month";
+    if ($month < 1) {
+      $year--;
+      $month += 12;
+    } elseif ($month > 12) {
+      $year++;
+      $month -= 12;
+    }
+
+    if ($blog_fancyurl) {
+      return sprintf("%s/%04d/%02d", $blog_baseurl, $year, $month);
+    } else {
+      return sprintf("%s/index.php?archive=%04d%02d", $blog_baseurl, $year, $month);
+    }
   }
 
-  function get_month_alt($year, $month) {
-    if ($month<1) {
-      --$year;
-      $month = 12;
-    } elseif ($month>12) {
-      ++$year;
-      $month = 1;
+  function getMonthAnchor($year, $month) {
+    if ($month < 1) {
+      $year--;
+      $month += 12;
+    } elseif ($month > 12) {
+      $year++;
+      $month -= 12;
     }
     return date("F Y", mktime(0, 0, 0, $month, 1, $year));
   }
 
-
-  function get_calendar() {
+  function getCalendar() {
     global $blog_baseurl;
+
     $year = $this->year;
     $month = $this->month;
-
-    $num_days = date("t", mktime(0, 0, 0, $month, 1, $year));
-    $fDoWoM = date("w", mktime(0, 0, 0, $month, 1, $year));
-    $cal = "<div id=\"calendar\">
-      <a href=\"".$this->get_month_href($year,$month-1)."\" title=\"".$this->get_month_alt($year, $month-1)."\">«</a>
-      <a href=\"".$this->get_month_href($year,$month)."\">".$this->get_month_alt($year, $month)."</a>
-      <a href=\"".$this->get_month_href($year,$month+1)."\" title=\"".$this->get_month_alt($year, $month+1)."\">»</a>
-      <div class=\"calendar_days\">
-      <table cellpadding=0 cellspacing=0 width=\"95%\">
-      <tr>
-      <td align=\"right\" width=\"15.0%\">Sun</td>
-      <td align=\"right\" width=\"14.2%\">Mon</td>
-      <td align=\"right\" width=\"14.2%\">Tue</td>
-      <td align=\"right\" width=\"14.2%\">Wen</td>
-      <td align=\"right\" width=\"14.2%\">Thu</td>
-      <td align=\"right\" width=\"14.2%\">Fri</td>
-      <td align=\"right\" width=\"14.2%\">Sat</td>
-      </tr>
-      <tr>";
-    $nweeks = (int) (($num_days+$fDoWoM)/7)+1;
-    if ($num_days+$fDoWoM == 35)
-      --$nweeks;
-
-    $total = 0;
-    $today = 1;
-    $days = $this->get_bloged_days($year, $month);
-    $bloged_days = array_flip($days);
-
-    while ($total++<$nweeks*7) {
-      if ($total%7==1) {
-	$cal .= "<tr>\n";
+    
+    $ndays = date("t", mktime(0, 0, 0, $month, 1, $year));
+    $_weekday = date("w", mktime(0, 0, 0, $month, 1, $year));
+    $entries = $this->getEntriesForCalendar($year, $month);
+    $cal = "<div id=\"calendar\">\n".
+      "<p><a href=\"".$this->getMonthHref($year, $month-1)."\" title=\"".$this->getMonthAnchor($year, $month-1)."\">&laquo;</a>\n".
+      "<a href=\"".$this->getMonthHref($year, $month)."\" class=\"current\">".$this->getMonthAnchor($year, $month)."</a>\n".
+      "<a href=\"".$this->getMonthHref($year, $month+1)."\" title=\"".$this->getMonthAnchor($year, $month+1)."\">&raquo;</a></p>\n".
+      "<table>\n".
+      "<tr class=\"header\"><th>S</th><th>M</th><th>T</th><th>W</th><th>T</th><th>F</th><th>S</th></tr>\n";
+
+    $weekday = 0;
+    for ($day=1-$_weekday; $day<=$ndays; $day++) {
+      if ($weekday == 0) {
+        $cal .= "<tr>";
       }
-      if ($today<$num_days+1 && $total>$fDoWoM) {
-	if (in_array($today, $bloged_days)) {
-	  $e = new Entry($days[$today]);
-	  $cal .= "<td align=\"right\"><a href=\"" . $e->getHref() ."\">$today</a></td>";
-	} else {
-	  $cal .= "<td align=\"right\">$today</td>";
-	}
-	$today++;
+      if ($day < 1) {
+        $cal .= "<td></td>";
+      } elseif ($entries[$day]) {
+        $nentries = count($entries[$day]);
+        if ($nentries > 1) {
+          $title = "$nentries entries posted on this day";
+          $archive = new Archive($year, $month, $day);
+          $cal .= "<td><a href=\"".$archive->getHref()."\" title=\"$title\">$day</a></td>";
+        } else {
+          $title = "$nentries entry posted on this day";
+          $entry = new Entry($entries[$day][0]);
+          $cal .= "<td><a href=\"".$entry->getHref()."\" title=\"$title\">$day</a></td>";
+        }
       } else {
-	$cal .= "<td>&nbsp;</td>";
+        $cal .= "<td>$day</td>";
       }
-      if (!($total%7)) {
-	$cal .= "</tr>\n";
+      if ($weekday == 6) {
+        $cal .= "</tr>\n";
       }
+      $weekday = ($weekday + 1) % 7;
+    }
+    if ($weekday < 6) {
+      $cal .= "</tr>\n";
     }
-    $cal .= "</div></table></div>\n";
+    $cal .= "</table></div>\n";
     return $cal;
   }
 
-  function get_bloged_days($year, $month) {
-    $days = array();
-    $filenames = Soojung::queryFilenameMatch($year . $month . "[^.]+[.]entry$");
+  function getEntriesForCalendar($year, $month) {
+    $entries = array();
+    $filenames = Soojung::queryFilenameMatch(sprintf("^%04d%02d[^.]+[.]entry$", $year, $month));
+    sort($filenames);
     foreach($filenames as $filename) {
-      $key = sprintf("%d", substr($filename, 15, 2));
-      $day = $filename;
-      $days[$key] = $day;
+      list($datetime, $category, $entryid) = explode("_", substr(basename($filename), 0, -6));
+      $day = intval(substr($datetime, 6, 2));
+      if($entries[$day]) {
+        $entries[$day][] = $filename;
+      } else {
+        $entries[$day] = array($filename);
+      }
     }
-    $days = array_unique($days);
-
-    return $days;
+    return $entries;
   }
 }
 ?>
diff -urN soojung-0.4.4/classes/Category.class.php soojung/classes/Category.class.php
--- soojung-0.4.4/classes/Category.class.php	2005-01-07 21:18:00.000000000 +0900
+++ soojung/classes/Category.class.php	2005-02-12 22:53:01.000000000 +0900
@@ -63,4 +63,5 @@
 
 }
 
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/classes/Comment.class.php soojung/classes/Comment.class.php
--- soojung-0.4.4/classes/Comment.class.php	2004-11-26 22:58:36.000000000 +0900
+++ soojung/classes/Comment.class.php	2005-02-12 22:53:01.000000000 +0900
@@ -119,4 +119,5 @@
 
 }
 
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/classes/Entry.class.php soojung/classes/Entry.class.php
--- soojung-0.4.4/classes/Entry.class.php	2005-01-11 21:06:59.000000000 +0900
+++ soojung/classes/Entry.class.php	2005-02-19 05:37:25.000000000 +0900
@@ -61,7 +61,7 @@
     }
   }
 
-  function getBody($toHtml = true) {
+  function getRawBody() {
     $fd = fopen($this->filename, "r");
     fgets($fd, 1024); // date
     fgets($fd, 1024); // title
@@ -71,26 +71,16 @@
     fgets($fd, 1024);
     $body = fread($fd, filesize($this->filename));
     fclose($fd);
-
-    // body convert to html
-    if ($toHtml == true) {
-      if ($this->format == "plain") {
-	$body = Formatter::plainToHtml($body);
-      } elseif ($this->format == "html") {
-	//do nothing :)
-      } elseif ($this->format == "bbcode") {
-        $body = Formatter::bbcodeToHtml($body);
-      }
-    } else {
-      if ($this->format == "html") {
-	$body = addslashes($body);
-      } else {
-	$body = htmlspecialchars($body);
-      }
-    }
+    
     return $body;
   }
 
+  function getBody() {
+    $body = $this->getRawBody();
+    $formatter = Soojung::getFormatter($this->format);
+    return $formatter->toHtml($body);
+  }
+
   function getCommentCount() {
     return Soojung::queryNumFilenameMatch("[.]comment$", "contents/" . $this->entryId . "/");
   }
@@ -262,4 +252,5 @@
   }
 }
 
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/classes/Export.class.php soojung/classes/Export.class.php
--- soojung-0.4.4/classes/Export.class.php	2004-10-02 19:39:37.000000000 +0900
+++ soojung/classes/Export.class.php	2005-02-12 22:53:01.000000000 +0900
@@ -52,4 +52,5 @@
 
 }
 
-?>
\ No newline at end of file
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/classes/Formatter.class.php soojung/classes/Formatter.class.php
--- soojung-0.4.4/classes/Formatter.class.php	2005-01-05 15:58:18.000000000 +0900
+++ soojung/classes/Formatter.class.php	2005-02-19 05:37:25.000000000 +0900
@@ -1,8 +1,126 @@
 <?php
 
+/** Balances Tags of string using a modified stack.
+ * @param text      Text to be balanced
+ * @return          Returns balanced text
+ * @notes           
+ * import from Wordpress
+ * add balance quot
+ */
+function balanceTags($text, $is_comment = 0) {
+  /*	
+  if (get_settings('use_balanceTags') == 0) {
+    return $text;
+  }
+  */
+  $tagstack = array(); 
+  $stacksize = 0; 
+  $tagqueue = ''; 
+  $newtext = '';
+
+# WP bug fix for comments - in case you REALLY meant to type '< !--'
+  $text = str_replace('< !--', '<    !--', $text);
+# WP bug fix for LOVE <3 (and other situations with '<' before a number)
+  $text = preg_replace('#<([0-9]{1})#', '&lt;$1', $text);
+
+  // close &quot; which isn't closed in MARKUP
+  $text = ereg_replace("<([^=]*)=\"([^>\"]*)>", "<\\1=\"\\2\">", $text);
+  // match MARKUP tag, $regex[1] is tagname.
+
+  while (preg_match("/<(\/?\w*)\s*([^>]*)>/",$text,$regex)) {
+    $newtext = $newtext . $tagqueue;
+
+    $i = strpos($text,$regex[0]);
+    $l = strlen($tagqueue) + strlen($regex[0]);
+
+    // clear the shifter
+    $tagqueue = '';
+    // Pop or Push
+    if ($regex[1][0] == "/") { // End Tag
+      $tag = strtolower(substr($regex[1],1));
+      // if too many closing tags
+      if($stacksize <= 0) { 
+	$tag = '';
+	//or close to be safe $tag = '/' . $tag;
+      }
+      // if stacktop value = tag close value then pop
+      else if ($tagstack[$stacksize - 1] == $tag) { // found closing tag
+	$tag = '</' . $tag . '>'; // Close Tag
+	// Pop
+	array_pop ($tagstack);
+	$stacksize--;
+      } else { // closing tag not at top, search for it
+	for ($j=$stacksize-1;$j>=0;$j--) {
+	  if ($tagstack[$j] == $tag) {
+	    // add tag to tagqueue
+	    for ($k=$stacksize-1;$k>=$j;$k--){
+	      $tagqueue .= '</' . array_pop ($tagstack) . '>';
+	      $stacksize--;
+	    }
+	    break;
+	  }
+	}
+	$tag = '';
+      }
+    } else { // Begin Tag
+      $tag = strtolower($regex[1]);
+
+      // Tag Cleaning
+
+      // Push if not img or br or hr
+      if($tag != 'br' && $tag != 'img' && $tag != 'hr' ) {
+	$stacksize = array_push ($tagstack, $tag);
+      }
+
+      // Attributes
+      // $attributes = $regex[2];
+      $attributes = $regex[2];
+      if($attributes) {
+	$attributes = ' '.$attributes;
+      }
+      $tag = '<'.$tag.$attributes.'>';
+    }
+    $newtext .= substr($text,0,$i) . $tag;
+    $text = substr($text,$i+$l);
+  }  
+
+  // Clear Tag Queue
+  $newtext = $newtext . $tagqueue;
+
+  // Add Remaining text
+  $newtext .= $text;
+
+  // Empty Stack
+  while($x = array_pop($tagstack)) {
+    $newtext = $newtext . '</' . $x . '>'; // Add remaining tags to close      
+  }
+
+  // WP fix for the bug with HTML comments
+  $newtext = str_replace("< !--","<!--",$newtext);
+  $newtext = str_replace("<    !--","< !--",$newtext);
+
+  return $newtext;
+}
+
 class Formatter {
 
-  function plainToHtml($str) {
+  function toHtml($str) {
+    return htmlspecialchars($str);
+  }
+
+  function toRSS($str) {
+    return $this->toHtml($str);
+  }
+
+  function onPost($str) {
+    return $str;
+  }
+
+}
+
+class PlainFormatter extends Formatter {
+
+  function toHtml($str) {
     $pos = strpos($str, "<pre");
     if ($pos === false) {
       return nl2br($str);
@@ -22,7 +140,27 @@
     return $text;
   }
 
-  function __bbcode_listing($mode, $str) {
+  function onPost($str) {
+    return balanceTags($str);
+  }
+
+}
+
+class HtmlFormatter extends Formatter {
+
+  function toHtml($str) {
+    return $str;
+  }
+
+  function onPost($str) {
+    return balanceTags($str);
+  }
+
+}
+
+class BBcodeFormatter extends Formatter {
+
+  function __listing($mode, $str) {
     $item = explode("[*]", $str);
     $rstr = trim($item[0]);
     for($i=1;$i<count($item);$i++) {
@@ -38,11 +176,11 @@
     }
   }
 
-  function __bbcode_escape($str) {
+  function __escape($str) {
     return strtr($str, array("@"=>"\0@", "://"=>"\0://", "["=>"[\0"));
   }
 
-  function bbcodeToHtml($str) {
+  function toHtml($str) {
     static
       $rule1 = array(
         '#\[i](.+)\[/i]#iU',
@@ -70,12 +208,12 @@
         '<span style="font-size:\2pt;">\3</span>',
         '<blockquote><div>\1</div></blockquote>',
         '<blockquote><p class="quotetitle">\2</p><div>\3</div></blockquote>',
-        'Formatter::__bbcode_listing("\1","\2")',
-        'Formatter::__bbcode_escape("<a href=\\"\1\\">\1</a>")',
-        'Formatter::__bbcode_escape("<a href=\\"\2\\">\3</a>")',
-        'Formatter::__bbcode_escape("<img src=\\"\1\\" width=\\"\\" height=\\"\\" alt=\\"\1\\\" />")',
-        'Formatter::__bbcode_escape("<img src=\\"\2\\" width=\\"\\" height=\\"\\" alt=\\"\3\\\" />")',
-        'Formatter::__bbcode_escape("<a href=\\"mailto:\1\\">\1</a>")'),
+        'BBcodeFormatter::__listing("\1","\2")',
+        'BBcodeFormatter::__escape("<a href=\\"\1\\">\1</a>")',
+        'BBcodeFormatter::__escape("<a href=\\"\2\\">\3</a>")',
+        'BBcodeFormatter::__escape("<img src=\\"\1\\" width=\\"\\" height=\\"\\" alt=\\"\1\\\" />")',
+        'BBcodeFormatter::__escape("<img src=\\"\2\\" width=\\"\\" height=\\"\\" alt=\\"\3\\\" />")',
+        'BBcodeFormatter::__escape("<a href=\\"mailto:\1\\">\1</a>")'),
       $rule2 = array(
         '#http://(?:[-0-9a-z_.@:~\\#%=+?/]|&amp;)+#i',
         '#[-0-9a-z_.]+@[-0-9a-z_.]+#i'),
@@ -131,7 +269,7 @@
         if($option["smiley"]) {
           $temp = strtr($temp, $smiley);
         }
-        $temp = preg_replace('#\[literal](.*)\[/literal]#ieU', 'Formatter::__bbcode_escape("\1")', $temp);
+        $temp = preg_replace('#\[literal](.*)\[/literal]#ieU', 'BBcodeFormatter::__escape("\1")', $temp);
         $temp = preg_replace($rule2, $repl2, preg_replace($rule1, $repl1, $temp));
         $rstr .= nl2br(str_replace("\0", "", $temp));
       } else {
@@ -142,4 +280,5 @@
   }
 }
 
+# vim: ts=8 sw=2 sts=2 noet
 ?>
